#define EXPORT_SYMTAB
#include <linux/module.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/fs.h>
#include <linux/evl_log.h>

#define EVLPRINT_SEV	3 
#define EVLWRITE_SEV 	3
#define EVLLOGK_SEV 	3

/*
 * Error IDs
 */
#define EVLPRINT_ERR	2000 
#define EVLLOG_ERR  	2000 
#define EVWRITE_ERR 	2000 

static void test_mod_symbol_lookup();

int
init_module(void)
{
	posix_log_printf(LOG_KERN, EVLPRINT_ERR, EVLPRINT_SEV, 0, "Symtest with posix_log_printf: [<%p>].\n",  __builtin_return_address(0));
	printk("Symtest with printk: [<%p>].\n", __builtin_return_address(0));
	return 0;
}

void
cleanup_module(void)
{
	test_mod_symbol_lookup();
	printk("Symbol lookup test is done.\n");
}

static void
test_mod_symbol_lookup()
{
	printk("Module symbol lookup test. [<%p>].\n",  test_mod_symbol_lookup);
}

EXPORT_SYMBOL(test_mod_symbol_lookup);

MODULE_LICENSE("GPL");
