#!/bin/bash

lastRecid=`/sbin/evlview -t 1 -S %recid%`
TEST_TEMPLATE=symtest.out

/sbin/insmod symtest.o
if [ $? -ne 0 ]
then
	echo Failed to install kernel test module symtest.o
	echo 	:ABORTED
	exit 2
fi
sleep 1
killall -USR1 evlogd
/sbin/rmmod symtest

/sbin/evlview -f "recid > $lastRecid && facility=kern" -B -S '%data%' | sed "s/+.*//g" > test6.sh.out

diff test6.sh.out $TEST_TEMPLATE
if [ $? -eq "0" ]
then
        echo symtest    :PASSED
        rm test6.sh.out
else
        echo symtest    :FAILED
fi

exit 0
